/*
* Template-File src/main/takatuka/templates/EntityAbstractSearch.vm
*/
package de.ivu.elect.business.wahlausschuss.boundary;

import java.util.List;

import javax.inject.Inject;

import de.ivu.elect.business.wahlausschuss.entity.WahlausschussEntschaedigung;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.jee.presentation.search.WildcardConverter;

public abstract class AbstractWahlausschussEntschaedigungSearch {

  @Inject
  protected transient WahlausschussEntschaedigungExtendedDAO dao;

  public AbstractWahlausschussEntschaedigungSearch() {
    super();
  }

  public List<WahlausschussEntschaedigung> getSearchResult(WahlausschussEntschaedigungSearchParameters searchParameters, EagerLoadingCollector<WahlausschussEntschaedigung> eagerLoadingCollector) {
    return eagerLoadingCollector.eagerLoad(querySearchResult(searchParameters));
  }

  protected abstract List<WahlausschussEntschaedigung> querySearchResult(WahlausschussEntschaedigungSearchParameters searchParameters);

  protected String convertSearchPattern(String patternInput) {
    return new WildcardConverter().addAndConvertToJpqlLikeExpression(patternInput);
  }
}
